//przykladowa implementacja sortowania pozycyjnego
//(radix sort)
//sortujemy liczby 8 bitowe

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>

using namespace std;

#define maxsize 9
#define maxbit 7
void swap(unsigned short *t, int i, int j){
	unsigned short pom=t[i];
	t[i]=t[j];
	t[j]=pom;
}



unsigned short aux[maxsize];

//sprawdzanie bitu bit liczby i
int check_bit(unsigned short i,int bit){
	if(i & (1<<bit))
		return 1;
	return 0;
}

//stabilne sortowanie tablicy t po bicie o numerze bit
//a - tablica pomocnicza
//size<=max_size

void stable_binary_sort(unsigned short* t, unsigned short* a, int size, int bit){
	int count=0;
	int i,j,k=0;
	for(i=0;i<size;i++)
		if(check_bit(t[i],bit)==0)
			count++;
	for(i=0;i<size;i++)
		if(check_bit(t[i],bit)==0)
			a[k++]=t[i];
		else
			a[count++]=t[i];	
	for(i=0;i<size;i++)
		t[i]=a[i];

}


// sortowanie pozycyjne
void radixsort(unsigned short* t, int size){
	for(int i=0;i<=maxbit;i++){
		stable_binary_sort(t,aux,size,i);
		//wypisanie tablicy - tylko dla ilustracji
		for(int j=0;j<size;j++)
			cout<<t[j]<<", ";
		cout<<endl;
	}
		
}

int main(void){
unsigned short t[maxsize]={12,3,4,5,1,4,9,8,13};

cout<<"Tablica wejsciowa"<<endl;
for(int i=0;i<maxsize;i++)
	cout<<t[i]<<", ";
cout<<endl<<endl;

cout<<"Sortowanie pozycyjne"<<endl;
radixsort(t,maxsize);
cout<<endl;

cout<<"Posortowana tablica"<<endl;
for(int i=0;i<maxsize;i++)
	cout<<t[i]<<", ";
cout<<endl<<flush;

system("read -p \"Press [Enter]\" "); //Linux
//system("pause"); //DOS
return 1;
}